/* Raul Galvan
   CMPS 161 Final
   3/15/10
 */
#define _CRT_SECURE_NO_DEPRECATE
#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>         /* glut.h includes gl.h and glu.h */
#endif
//#include "glut.h"
#include <stdlib.h>
#include <stdio.h>
#include <cstdlib>
#include <time.h>
#include <math.h>
#include <fstream>
#include <iostream>
#include <sstream>
#include <vector>

using namespace std;

#define MAX_PARTICLES 400

bool active = true;
float slowdown = 0.8; //Slow down particle
float xParticleSpeed;
float yParticleSpeed;
float camZoom = 0;
GLuint loop; //Loop variable
GLuint col; //Current color selection

int boxIndex = 0;
//Vector for collision box
struct Vector3 {
	float x;
	float y;
	float z;
};

//Bounding box for collision
struct BoundingBox {
	Vector3 max;
	Vector3 min;
};

//Init the bounding box
void initBox(BoundingBox *b){
	b->min.x = 100000;
	b->min.y = 100000;
	b->min.z = 100000;

	b->max.x = -100000;
	b->max.y = -100000;
	b->max.z = -100000;
}

//For particles
typedef struct {
	bool active; //Is particle active?
	float life;
	float fade; //Fade speed

	float r; //Red value
	float g; //Green value
	float b; //Blue value

	float xPos; //X position
	float yPos; //Y Position
	float zPos; //Z position

	float xi; //X direction
	float yi; //Y direction
	float zi; //Z direction

	float xg; //X gravity
	float yg; //Y gravity
	float zg; //Z gravity
}particles;

particles particle[MAX_PARTICLES]; //Particle array

static GLfloat colors[12][3]=				// Rainbow Of Colors
{
	{1.0f,0.5f,0.5f},{1.0f,0.75f,0.5f},{1.0f,1.0f,0.5f},{0.75f,1.0f,0.5f},
	{0.5f,1.0f,0.5f},{0.5f,1.0f,0.75f},{0.5f,1.0f,1.0f},{0.5f,0.75f,1.0f},
	{0.5f,0.5f,1.0f},{0.75f,0.5f,1.0f},{1.0f,0.5f,1.0f},{1.0f,0.5f,0.75f}
};

/**** Read our model data ****/
struct coord{
   float x,y,z;
};

//Vector inputs
typedef vector<int> intVec;
vector<coord*> vertexNormal;
vector<coord*> faceNormal;
vector<coord*> coordinates;
vector<intVec*> sharedVertex;
vector<intVec*> polygons;
int vertCount,polyCount;//vector and polygon counts

//For the window
int globalHeight;
int globalWidth;

//To update Projection mode
void UpdateProjection(GLboolean toggle = GL_TRUE);

//Create light components
float diffuseLight[] = {1, 0, 0, 1};
float position[] = { 0, 0, 5, .5 };//Light position
const GLfloat white[] = {1.0, 1.0, 1.0, 1.0};
const GLfloat green[] = {0.0f, 1.0, 0.0, 1.0};

//Translation values for light
GLfloat move_lightx = -50.0;
GLfloat move_lighty = 50.0;
GLfloat move_lightz = 0.0;

double angle; //For circle
double xCir = 25;
double yCir = 25;
double radius = 5;

//Attenuation for light
GLfloat const_att = 1.0;

//Other data
float AltMouseX, AltMouseY;
bool Mclick, Rclick, Lclick = false;
bool RotateOnX, RotateOnY, RotateOnZ = false;
double scale = 15;
bool stateDown = false;
int currObj; //For selecting light sphere

//Mouse position
float NewMousePosX;
float NewMousePosY;

float staticPosX;
float staticPosY;

//For new light sphere position
float newLightPosX;
float newLightPosY;

//For rotation and translation
float x, y, z = 0.0f;
float xRotate, yRotate, zRotate = 0.0f;
bool xTrans, yTrans, zTrans = false;
float TransOnX, TransOnY, TransOnZ = 0.0f;

//For planes and scaling
bool PlanesOn = true;
bool scaleOn = false;

//Move the scene and camera
bool moveScene = false;
bool CamHoriz, CamVert = false;
bool CamRoll, CamPitch, CamYaw = false;
float CamX = 0.0f;
float CamY = 1.75f;
float CamZ = 5.0f;
float NewCamX = 0.0f;
float NewCamY = 0.0f;
float NewCamZ = -1.0f;
float zoomz=0;

//For different rendering styles and shadow
bool wireFrame = false;
bool constantShade = true;
bool gShade = false;
bool isShadowOn = false;

/*****************************READ THE FILES ********************************/
//Read the coordinates file
void ReadCoord(){  
   fstream is ("surfboard.coor", fstream::in);
   is >> vertCount;
   coord *area = new coord;
   coordinates.push_back(area);
   for(int i = 1; i <= vertCount; i++){
      coord *temp = new coord;
      int num;
      char extra;
      is >> num >> extra;
      is >> temp->x >> extra >> temp->y >> extra >> temp->z;
      coordinates.push_back(temp);
   }
   is.close();
}

//Read the polygon file
void ReadPoly(){
   fstream is("surfboard.poly", fstream::in);
   is >> polyCount;
   for(int i = 0; i <= polyCount; i++){
      intVec *poly = new intVec;
      char name[256];
      stringbuf buf;
      is.getline(name, 256);
      buf.sputn(name, 256);
      istream tempstream(&buf);
      tempstream >> name;
      while(tempstream.good()){
         int tempInt;
         tempstream >> tempInt;
         if(!tempstream.good()){
            break;  
         }
         poly->push_back(tempInt);
      }
      polygons.push_back(poly);
   }
}

/*****************************************************************************/

//Average for vector
coord* avgVector(int currVertex){
   coord* temp = new coord;
   temp->x = 0;
   temp->y = 0;
   temp->z = 0;
   for(int i = 0; i <= sharedVertex[currVertex] -> size() - 1; i++){
       temp -> x += faceNormal[(*sharedVertex[currVertex])[i]] -> x;
	   temp -> y += faceNormal[(*sharedVertex[currVertex])[i]] -> y;
	   temp -> z += faceNormal[(*sharedVertex[currVertex])[i]] -> z;
   }
   temp -> x = temp -> x/sharedVertex[currVertex] -> size();
   temp -> y = temp -> y/sharedVertex[currVertex] -> size();
   temp -> z = temp -> z/sharedVertex[currVertex] -> size();
   return temp;
}

//Cross product
coord* cProduct(coord a, coord b){
   coord* temp = new coord;
   temp -> x = (a.x*b.y) - (a.y*b.x);
   temp -> y = (a.x*b.z) - (a.z*b.x);
   temp -> z = (a.y*b.z) - (a.z*b.y);
   return temp;
}

//Normalization of vectors: x/length, y/length
void Normalize(coord* a){
   float length = sqrt(a->x * a->x + a->y * a->y + a->z * a->z);
   a->x = a->x/length;
   a->y = a->y/length;
   a->z = a->z/length;
}

//Getting the vertex normal
void calcVertNorm(){
   coord *sample = new coord;
   sample -> x = 0;
   sample -> y = 0;
   sample -> z = 0;
   vertexNormal.push_back(sample);
   intVec *addIntVec = new intVec;
   sharedVertex.push_back(addIntVec);
   for(int currVertex = 1; currVertex <= vertCount; currVertex++){
      intVec *tempVect = new intVec;
      //Move through polygons
      for(int i = 1; i <= polyCount; i++){
         //Move through current int array of polygons
         for(int j = 0; j <= polygons[i] -> size() - 1; j++){
            if((*polygons[i])[j] == currVertex){
               tempVect -> push_back(i);
            }
         }  
      }
      sharedVertex.push_back(tempVect);
   }
   //Move through shared vertices
   for(int currVertex = 1; currVertex <= vertCount; currVertex++){
      //Create an average vector for each iteration
      coord* temp = avgVector(currVertex);
      Normalize(temp);
      vertexNormal.push_back(temp);
   }
}

//Cross product on two vectors and get the normal
void getFaceNormal(){
   coord *space = new coord;
   space -> x = 0;
   space -> y = 0;
   space -> z = 0;

   faceNormal.push_back(space);
   for(int i = 1; i <= polygons.size() - 1; i++){
      coord temp1; //Only used within the loop
      coord temp2;
      temp1.x = (coordinates[(*(polygons[i]))[0]]) -> x - (coordinates[(*(polygons[i]))[1]]) -> x;
      temp1.y = (coordinates[(*(polygons[i]))[0]]) -> y - (coordinates[(*(polygons[i]))[1]]) -> y;
      temp1.z = (coordinates[(*(polygons[i]))[0]]) -> z - (coordinates[(*(polygons[i]))[1]]) -> z;

      temp2.x = (coordinates[(*(polygons[i]))[2]]) -> x - (coordinates[(*(polygons[i]))[1]]) -> x;
      temp2.y = (coordinates[(*(polygons[i]))[2]]) -> y - (coordinates[(*(polygons[i]))[1]]) -> y;
      temp2.z = (coordinates[(*(polygons[i]))[2]]) -> z - (coordinates[(*(polygons[i]))[1]]) -> z;

      //Actual cross product
      coord* temp = cProduct(temp1,temp2);
      Normalize(temp);
      faceNormal.push_back(temp);
   }
}

//Check if a point is in the box
bool collision(BoundingBox *b,GLfloat x, GLfloat y, GLfloat z){
	return x <= b->max.x && x >= b->min.x &&
		   y <= b->max.y && y >= b->min.y &&
		   z <= b->max.z && y >= b->min.z;
}

//The collision test
bool collisionTest(float x, float y, float z){
	bool isHit = false;
	for(int i = 0; i < 1; i++){
		
	}
	return isHit;
}
//Draw Wireframe Enterprise ship
void DrawWirePoly(){
   glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
   glColor3f(0.9,0.9,0.9);
   glScalef(scale,scale,scale);
   glTranslatef(TransOnX, -TransOnY, TransOnZ);
   glPushMatrix();
   for(int i = 1; i <= polyCount; i++){
      glBegin(GL_POLYGON);   
      for(int j = 0; j <= (polygons[i]->size()-1); j++){
         glVertex3f(coordinates[((*(polygons[i]))[j])]->x,
                    coordinates[((*(polygons[i]))[j])]->y,
                    coordinates[((*(polygons[i]))[j])]->z);
      }
      glEnd();
   }
   glPopMatrix();
}

//Draw Gouraud Enterprise ship (Smooth shading)
void DrawGouraudPoly(){
   glScalef(scale,scale,scale);
   glTranslatef(TransOnX, -TransOnY, TransOnZ);
   glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
   glPushMatrix();
   for(int i = 1; i <= polyCount; i++){
      glBegin(GL_POLYGON);
	     glColor3f(1,0,0);
         for(int j = 0; j <= (polygons[i]->size()-1); j++){
		    GLfloat temp[] = {vertexNormal[(*polygons[i])[j]] -> x,
			               vertexNormal[(*polygons[i])[j]] -> y,
						   vertexNormal[(*polygons[i])[j]] -> z};
		  glNormal3fv(temp);
		  glVertex3f(coordinates[(*polygons[i])[j]]->x,
			         coordinates[(*polygons[i])[j]]->y,
					 coordinates[(*polygons[i])[j]]->z);
	  }
	  glEnd();
   }
   glPopMatrix();
}

//Draw Constant Enterprise ship (Flat shading)
void DrawConstantPoly(){
   glScalef(scale,scale,scale);
   glTranslatef(TransOnX, -TransOnY, TransOnZ);
   glPushMatrix();
   for(int i = 1; i <= polyCount; i++){
      glBegin(GL_POLYGON);
	     glColor3f(1,0,0);
         GLfloat temp[] = {faceNormal[i] -> x,
		                   faceNormal[i] -> y,
			               faceNormal[i] -> z};
	     glNormal3fv(temp);
	     for(int j = 0; j <= polygons[i] -> size()-1; j++){
	     glVertex3f(coordinates[(*polygons[i])[j]] -> x,
		            coordinates[(*polygons[i])[j]] -> y,
		            coordinates[(*polygons[i])[j]] -> z);
         }
      glEnd();
   }
   glPopMatrix();
}

//Draw the X,Y,Z planes
void drawPlanes(void){
   glScalef(1.5,1.5,1.5);
   glPushMatrix();
   glLineWidth (1.0);

   glDisable(GL_LIGHTING);
   //Are the planes on or off?
   if(PlanesOn){
      glBegin (GL_LINES);
         glColor3f (1,0,0); // X axis is red.
         glVertex3f(x,y,z);
         glVertex3f(50,y,z);
         glColor3f (0,1,0); // Y axis is green.
         glVertex3f(x,y,z);
         glVertex3f(x,50,z);
         glColor3f (0,0,1); // z axis is blue.
         glVertex3f(x,y,z);
         glVertex3f(x,y,50);
      glEnd();

      glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
   }
   glPopMatrix();

   glEnable(GL_LIGHTING);
}

//Pick the sphere of light
void drawLight(GLenum mode){ 
   glPushMatrix();
      glTranslatef(xCir,yCir,0);
      if(mode == GL_SELECT) glLoadName(1);

      //glTranslatef(-move_lightx,move_lighty,move_lightz);
      glLightf(GL_LIGHT0,GL_CONSTANT_ATTENUATION,const_att);
      glLightfv(GL_LIGHT0,GL_POSITION,position);
      glDisable(GL_LIGHTING);
      //glColor3d(0.9,0.9,0.5);
      //glutSolidSphere(5,40,50);
	  //Draw circle and name for picking
   glColor3f(0.9f,0.9f,0.5f);
   glBegin(GL_TRIANGLE_FAN);
      for(angle = 0; angle < 360; angle++){
         glVertex2f(xCir + sin(angle)*radius, yCir + cos(angle)*radius);
      }
   glEnd();
      glEnable(GL_LIGHTING);
   glPopMatrix();
}

//Draw collision box
void drawBox(BoundingBox *b){
	glColor3f(1,1,1);
	glBegin(GL_LINE_LOOP);
		glVertex3f(b->max.x,b->max.y,b->min.z); //0
		glVertex3f(b->min.x,b->max.y,b->min.z); //1
		glVertex3f(b->min.x,b->min.y,b->min.z); //2
		glVertex3f(b->max.x,b->min.y,b->min.z); //3
	glEnd();

	glBegin(GL_LINE_LOOP);
		glVertex3f(b->max.x,b->min.y,b->max.z); //4
		glVertex3f(b->max.x,b->max.y,b->max.z); //5
		glVertex3f(b->min.x,b->max.y,b->max.z); //6
		glVertex3f(b->min.x,b->min.y,b->max.z); //7
	glEnd();

	glBegin(GL_LINE_LOOP);
		glVertex3f(b->max.x,b->max.y,b->min.z); //0
		glVertex3f(b->max.x,b->max.y,b->max.z); //5
		glVertex3f(b->min.x,b->max.y,b->max.z); //6
		glVertex3f(b->min.x,b->max.y,b->min.z); //1
	glEnd();

	glBegin(GL_LINE_LOOP);
		glVertex3f(b->max.x,b->min.y,b->max.z); //4
		glVertex3f(b->min.x,b->min.y,b->max.z); //7
		glVertex3f(b->min.x,b->min.y,b->min.z); //2
		glVertex3f(b->max.x,b->min.y,b->min.z); //3
	glEnd();
}
//Draw particles on screen
void drawParticles(){
	glDisable(GL_LIGHTING);
	glPushMatrix();
		for(loop = 0; loop < MAX_PARTICLES; loop++){
			if(particle[loop].active){ //If particle is active
				float x = particle[loop].xPos; //Get particle x position
				float y = particle[loop].yPos; //Get particle y position
				float z = particle[loop].zPos + camZoom; //Particle Z position + zoom

				glColor4f(particle[loop].r,particle[loop].g,particle[loop].b,particle[loop].life);

				glBegin(GL_TRIANGLE_STRIP);
					glVertex3f(x + 0.1, y + 0.1, z); //Top right
					glVertex3f(x - 0.1, y + 0.1, z); //Top left
					glVertex3f(x + 0.1, y - 0.1, z); //Bottom right
					glVertex3f(x - 0.1, y - 0.1, z); //Bottom left
				glEnd();

				particle[loop].xPos += particle[loop].xi/(slowdown*1000); //Move on the X axis by x speed
				particle[loop].yPos += particle[loop].yi/(slowdown*1000); //Move on the Y axis by y speed
				particle[loop].zPos += particle[loop].zi/(slowdown*1000); //Move on the Z axis by z speed

				particle[loop].xi += particle[loop].xg; //Take pull on X axis into account
				particle[loop].yi += particle[loop].yg; //Take pull on Y axis into account
				particle[loop].zi += particle[loop].zg; //Take pull on Z axis into account

				particle[loop].life -= particle[loop].fade; //Reduce particles life by "fade"

				if(particle[loop].life < 0){ //If particle is burned out
					particle[loop].life = 1; //Give particle new life
					particle[loop].fade = float(rand()%100)/1000 + 0.003f;

					particle[loop].xPos = 0; //Center on X axis
					particle[loop].yPos = 0; //Center on Y axis
					particle[loop].zPos = 0; //Center on Z axis

					particle[loop].xi = xParticleSpeed + float((rand()%60) - 32); //X axis speed and direction
					particle[loop].yi = yParticleSpeed + float((rand()%60) - 30); //Y axis speed and direction
					particle[loop].zi = float((rand()%60) - 30); //Z axis speed and direction

					particle[loop].r = colors[col][0]; //Select red from color table
					particle[loop].g = colors[col][1]; //Select green from color table
					particle[loop].b = colors[col][2]; //Select blue from color table
				}
			}
		}
	glPopMatrix();
	glEnable(GL_LIGHTING);
}

void display(){
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   glEnable(GL_DEPTH_TEST);
   glLoadIdentity();
   
   //Moveable light source
   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);
   glEnable(GL_NORMALIZE);
   glLightfv(GL_LIGHT0, GL_DIFFUSE, green);
   glLightfv(GL_LIGHT0, GL_SPECULAR, green);

   //Main light source
   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT1);
   glEnable(GL_NORMALIZE);
   glLightfv(GL_LIGHT1, GL_DIFFUSE, white);
   glLightfv(GL_LIGHT1, GL_SPECULAR, white);
   
   //drawLight(GL_RENDER);//For picking of light sphere

   gluLookAt(50.0, 50.0, 50.0, 0, 0, 0, 0, 1, 0);
   drawPlanes();
   drawParticles();
   glRotatef(xRotate, 1.0, 0.0, 0.0);
   glRotatef(yRotate, 0.0, 1.0, 0.0);
   glRotatef(zRotate, 0.0, 0.0, 1.0);
   glTranslatef(x, y, z);
   
   glPushMatrix();
	   glScalef(0.1,0.1,0.1);
	   glTranslatef(0,120,0);
	   if(wireFrame){
		  DrawWirePoly();
	   }
	   else if(constantShade){
		   DrawConstantPoly();
	   }
	   else if(gShade){
		   DrawGouraudPoly();
	   }
   glPopMatrix();

   glDisable(GL_LIGHTING);
   //glutPostRedisplay();
   glTranslatef(0,0,zoomz);
   glutSwapBuffers();
}

void reshape(int w, int h)
{
   glViewport(0, 0, w, h);
   globalWidth = w;
   globalHeight = h;
   
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glOrtho(-50, 50.0, -50.0, 50.0, -50.0, 50.0);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   UpdateProjection();
}

void init(){
   glClear(GL_COLOR_BUFFER_BIT); //Clear the window
   //Set to wireframe
   glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
   glShadeModel(GL_SMOOTH);
}

void initParticles(){
	glShadeModel(GL_SMOOTH);
	glClearDepth(1.0f);
	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
	glHint(GL_POINT_SMOOTH_HINT,GL_NICEST);

	for(loop = 0; loop < MAX_PARTICLES; loop++){
		particle[loop].active = true; //Make all particles active
		particle[loop].life = 1.0f; //Give all particles life
		particle[loop].fade = float(rand()%100/1000 + 0.003); //Random fade speed

		particle[loop].r = colors[loop*(12/MAX_PARTICLES)][0]; //Select red color
		particle[loop].g = colors[loop*(12/MAX_PARTICLES)][1]; //Select red color
		particle[loop].b = colors[loop*(12/MAX_PARTICLES)][2]; //Select red color

		particle[loop].xi = float((rand()%50) - 26)*10; //Random speed on X axis
		particle[loop].yi = float((rand()%50) - 26)*10; //Random speed on Y axis
		particle[loop].zi = float((rand()%50) - 26)*10; //Random speed on Z axis

		particle[loop].xg = 0; //Horizontal pull to zero
		particle[loop].yg = 0.8f; //Verticle pull downward
		particle[loop].zg = 0; //Pull on Z axis to zero
	}
}

//Checks to see if keyboard key is not pressed
void UpKeys(unsigned char key, int x, int y){
   if(key = 'a'){
      RotateOnX = false;
   }
   if(key = 'b'){
      RotateOnY = false;
   }
   if(key = 'c'){
      RotateOnZ = false;
   }
   if(key = 's'){
      scaleOn = false;
   }
   if(key = 'x'){
      xTrans = false;
   }
   if(key = 'y'){
      yTrans = false;
   }
   if(key = 'z'){
      zTrans = false;
   }
}

//Keyboard input
void KeyboardKeys(unsigned char key,int x, int y){
   switch(key){
      case 27:
         exit(0);
         break;
      case 'a':
         if(RotateOnX ==false){
            RotateOnX = true;
         }
         else if(RotateOnX == true){
            RotateOnX = false;
         }
         RotateOnY = false;
         RotateOnZ = false;
      break;
      case 'b':
         if(RotateOnY == false){
            RotateOnY = true;
         }
         else if(RotateOnY = true){
            RotateOnY = false;
         }
         RotateOnX = false;
         RotateOnZ = false;
      break;
      case 'c':
         if(RotateOnZ == false){
            RotateOnZ = true;
         }
         else if(RotateOnZ = true){
            RotateOnZ = false;
         }
         RotateOnX = false;
         RotateOnY = false;
      break;
      case 'C':
         constantShade = true;
         wireFrame = false;
         gShade = false;
      break;
      case 'd':
         if(isShadowOn == true){
            isShadowOn =false;
	 }
	 else if(isShadowOn == false){
	         isShadowOn = true;
	 }
      break;
      case 'G':
         gShade = true;
         wireFrame = false;
         constantShade = false;
         break;
      case 'H':
         if(CamHoriz == false){
            CamHoriz = true;
         }
         break;
         case 'm':
         //if(moveScene == false){
          //  moveScene = true;
         //}
         zoomz = zoomz--;
         break;
      case 'M':
         //if(moveScene == false){
          //  moveScene = true;
         //}
         zoomz = zoomz++;
         break;
      case 'p':
         UpdateProjection(GL_TRUE);
         break;
      case 'P':
         if(CamPitch == false){
            CamPitch = true;
         }
         break;
      case 'q':
         const_att *= 0.9f;
         break;
      case 'Q':
         const_att /= 0.9f;
         break;
      case 'r':
         xRotate = 0.0f;
         yRotate = 0.0f;
         zRotate = 0.0f;
         NewMousePosX = 0;
         NewMousePosY = 0;
         scale = 15;
         RotateOnX = false;
         RotateOnY = false;
         RotateOnZ = false;
         TransOnX = 0;
         TransOnY = 0;
         TransOnZ = 0;
         wireFrame = false;
         constantShade = true;
         gShade = false;
         glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
         break;
      case 'R':
         if(CamRoll == false){
            CamRoll = true;
         }
         break;
      case 's':
         if(scaleOn == false){
            scaleOn = true;
         }else if(scaleOn == true){
            scaleOn = false;
         }
      break;
      case 'V':
         
         break;
      case 'W':
         wireFrame = true;
         constantShade = false;
         gShade = false;
         break;
      case 'x':
         if(xTrans == false){
            xTrans = true;
         }else if(xTrans == true){
            xTrans = false;
         }
         break;
      case 'y':
         if(yTrans == false){
            yTrans = true;
         }else if(yTrans == true){
            yTrans = false;
         }
         break;
      case 'Y':
         if(CamYaw == false){
            CamYaw = true;
         }
         break;
      case 'z':
         if(zTrans == false){
            zTrans = true;
         }else if(zTrans == true){
            zTrans = false;
         }
         break;
   }
   glutPostRedisplay();
}

//Use with arrow keys
void SpecialKeys(int key, int x, int y){
	switch(key){
		case GLUT_KEY_LEFT:
			if(xParticleSpeed > -200){
				xParticleSpeed -= 3.0f;
			}
		break;
		case GLUT_KEY_RIGHT:
			if(xParticleSpeed < 200){
				xParticleSpeed += 3.0f;
			}
		break;
		case GLUT_KEY_UP:
			if(yParticleSpeed < 200){
				yParticleSpeed += 3.0f;
			}
		break;
		case GLUT_KEY_DOWN:
			if(yParticleSpeed > -200){
				yParticleSpeed -= 3.0f;
			}
		break;
	}
}

//Checks to see if an object was clicked
void processHits(GLint hits, GLuint buffer[])
{
   unsigned int i, j;
   GLint names, *ptr;

   printf("hits = %d\n", hits);
   ptr = (GLint *) buffer;
   for (i = 0; i < hits; i++) {  /* for each hit  */
      names = *ptr;
	  ptr+=3;
      //printf(" number of names for hit = %d\n", names);
      for (j = 0; j < names; j++) {  /* for each name */
         printf("%d ", *ptr);
         if(*ptr == 1){
            currObj = *ptr;
         }
		 ptr++;
      }
      printf("\n");
   }
}



//For moving objects with mouse
void MouseMotion(int x, int y){
 
   GLint viewport[4];
   glGetIntegerv(GL_VIEWPORT, viewport);
   
   staticPosX = x - 250;
   staticPosY = y - 250;

   newLightPosX = x;
   newLightPosY = y-250;

   //To pick the light
   if(currObj == 1){
      xCir = x;
	  yCir = -y;
	  drawLight(GL_RENDER);
	  glClear(GL_COLOR_BUFFER_BIT);
   }

   //Moving mouse moves light left or right
  // move_lightx = 5 - (100 * x) / globalWidth;
   
   //Moving mouse up moves light upwards
  // move_lightz = 5 - (100 * y) / globalHeight;

   //If middle click and "M" key pressed
   if(Mclick == true && moveScene == true){
      
   }
   //If middle click and scaling
   if(Mclick == true && scaleOn == true){
      scale = staticPosY/55.6;
      if(scale < 15){
         scale = 15;
      }
      if(scale > 15){
         scale = 15;
      }
      glutPostRedisplay();   
   }
   //If right click and "H" pressed move horizontally
   if(Rclick == true && CamHoriz == true){
      if(staticPosX > AltMouseX){
         gluLookAt(CamX,CamY,CamZ,CamX + NewCamX,CamY + NewCamY,
                   CamZ + NewCamZ, 0,1,0);
      }
   }
   //If left click is down and rotation on x is true
   if(Lclick == true && stateDown == true && RotateOnX == true){
      if(staticPosX > AltMouseX){
         xRotate -= 5.0f; 
      }
      if(staticPosX < AltMouseX){
         xRotate += 5.0f;
      }
   }
   //If left click is down and rotation on y is true
   if(Lclick == true && stateDown == true && RotateOnY == true){
      if(staticPosY > AltMouseY){
         yRotate += 5.0f;  
      }
      if(staticPosY < AltMouseY){
         yRotate -= 5.0f;
      }
   }
   //If left click is down and rotation on z is true
   if(Lclick == true && stateDown == true && RotateOnZ == true){
      if(staticPosX > AltMouseY){
         zRotate += 5.0f;  
      }
      if(staticPosX < AltMouseY){
         zRotate -= 5.0f;
      }
   }
   //If right click and translation on x is true
   if(Rclick == true && xTrans == true){
      if(staticPosX < AltMouseX){
         TransOnX -= 5.0f;
      }else{
         TransOnX += 5.0f;
      }
   }
   //If right click and translation on y is true
   if(Rclick == true && yTrans == true){
      if(staticPosX < AltMouseX){
         TransOnY -= 5.0f;
      }else{
         TransOnY += 5.0f;
      }
   }
   //If right click and translation on z is true
   if(Rclick == true && zTrans == true){
      if(staticPosX < AltMouseX){
         TransOnZ += 5.0f;
      }else{
         TransOnZ -= 5.0f;
      }
   }
   glutPostRedisplay();
   //printf("X = %d\n",x);
   //printf("Y = %d\n",y);
   //printf("xCir = %d\n",xCir);
   //printf("yCir = %d\n",yCir);
}

//Mouse input
#define SIZE 512
void Mouse(int button, int state, int x, int y){
   GLuint selectBuf[SIZE];
   GLint hits;
   GLint viewport[4];

   if(button == GLUT_RIGHT_BUTTON){
      Rclick = true;
   }else{
      Rclick = false;
   }
   if(state == GLUT_DOWN){
      stateDown = true;
   }else{
      stateDown = false;
   }
   if(button == GLUT_MIDDLE_BUTTON){
      Mclick = true;
   }else{
      Mclick = false;
   }
   if(button == GLUT_LEFT_BUTTON){
      Lclick = true;
   }else{
      Lclick = false;
   }
   
   //Starts actual selecting
   if(Lclick == true && stateDown == true){
	  //Start picking
      glGetIntegerv(GL_VIEWPORT, viewport);
      glSelectBuffer(SIZE, selectBuf);
      glRenderMode(GL_SELECT);
      
      glInitNames();
      glPushName(0);

      glMatrixMode(GL_PROJECTION);
      glPushMatrix();
      glLoadIdentity();
      
      gluPickMatrix((GLdouble) x, (GLdouble) (viewport[3] - y),
                      5.0, 5.0, viewport);
      gluPerspective(45, (GLfloat) (viewport[2]-viewport[0])/(GLfloat) (viewport[3]-viewport[1]), 0.1f, 100.0f);

      //gluOrtho2D(0.0, 8, -0.5, 2.5);
      glMatrixMode(GL_MODELVIEW);
      drawLight(GL_SELECT);

      //Stops picking
      glMatrixMode(GL_PROJECTION);
      glPopMatrix();
      glMatrixMode(GL_MODELVIEW);
      
      hits = glRenderMode(GL_RENDER);
      processHits(hits, selectBuf);
   }
   else{
      currObj = 0;
   }
   
   AltMouseX = x - 250;
   AltMouseY = y - 250;
   glutPostRedisplay();
}

//Sets projection mode (if toggle is true, it's parallel, if false
//it's perspective
void UpdateProjection(GLboolean toggle){
   static GLboolean usePerspective = GL_TRUE;
   if(toggle){ //toggles control variable
      usePerspective = !usePerspective;
   }
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   
   //select correct projection
   if(usePerspective){ //perspective
      gluPerspective(90,globalWidth/globalHeight,.005,1000);
   }
   else{
      glOrtho(-25, 25.0, -25.0, 25.0, -25.0, 1000.0); //parallel
   }
   glMatrixMode(GL_MODELVIEW);
}

int main(int argc, char** argv){
   glutInit(&argc,argv); 
   glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);  
   glutInitWindowSize(500,500);
   glutInitWindowPosition(250,0); 
   glutCreateWindow("CMPS 161 Final Project"); 
   glutReshapeFunc(reshape);
   glutDisplayFunc(display);
   glutIdleFunc(display);
   glutMouseFunc(Mouse);
   glutMotionFunc(MouseMotion);
   glutKeyboardFunc(KeyboardKeys);
   glutKeyboardUpFunc(UpKeys);
   glutSpecialFunc(SpecialKeys);
   init();
   initParticles();
   ReadCoord();
   ReadPoly();
   getFaceNormal();
   calcVertNorm();
   glutMainLoop();
}
